您的位置:首页 > 其它

HDU 1728 逃离迷宫(dfs或bfs+剪枝)

2015-11-24 17:59 330 查看

逃离迷宫

Time Limit: 1000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 20447 Accepted Submission(s): 4974



[align=left]Problem Description[/align]
  给定一个m × n (m行, n列)的迷宫,迷宫中有两个位置,gloria想从迷宫的一个位置走到另外一个位置,当然迷宫中有些地方是空地,gloria可以穿越,有些地方是障碍,她必须绕行,从迷宫的一个位置,只能走到与它相邻的4个位置中,当然在行走过程中,gloria不能走到迷宫外面去。令人头痛的是,gloria是个没什么方向感的人,因此,她在行走过程中,不能转太多弯了,否则她会晕倒的。我们假定给定的两个位置都是空地,初始时,gloria所面向的方向未定,她可以选择4个方向的任何一个出发,而不算成一次转弯。gloria能从一个位置走到另外一个位置吗?

[align=left]Input[/align]
  第1行为一个整数t (1 ≤ t ≤ 100),表示测试数据的个数,接下来为t组测试数据,每组测试数据中,

  第1行为两个整数m, n (1 ≤ m, n ≤ 100),分别表示迷宫的行数和列数,接下来m行,每行包括n个字符,其中字符'.'表示该位置为空地,字符'*'表示该位置为障碍,输入数据中只有这两种字符,每组测试数据的最后一行为5个整数k, x1, y1, x2, y2 (1 ≤ k ≤ 10, 1 ≤ x1, x2 ≤ n, 1 ≤ y1, y2
≤ m),其中k表示gloria最多能转的弯数,(x1, y1), (x2, y2)表示两个位置,其中x1,x2对应列,y1, y2对应行。

[align=left]Output[/align]
  每组测试数据对应为一行,若gloria能从一个位置走到另外一个位置,输出“yes”,否则输出“no”。

[align=left]Sample Input[/align]

2
5 5
...**
*.**.
.....
.....
*....
1 1 1 1 3
5 5
...**
*.**.
.....
.....
*....
2 1 1 1 3


[align=left]Sample Output[/align]

no
yes


[align=left]Source[/align]
“网新恩普杯”杭州电子科技大学程序设计邀请赛

一 DFS

对于代码31行,为什么等于不能随便剪掉

如果剪掉就会出现下图结果:

【假如转弯数k=1,起点终点如图】

那么如果你的代码是优先向右搜索就会出错

红色的线是先搜的,由于最多转一次弯,所以不合题意;

蓝色是后搜的,因为遇到转弯数相等所以不往下走了了,但是继续走是可以满足题意输出"yes"的



#include <iostream>
using namespace std;
#define inf 0x3fffffff
#define M 105
//1、wan用于转弯数剪枝;2、step用于步数剪枝,就不用vis标记访问了
int r, c, ex, ey, k, wan[M][M];
char map[M][M];
int x_move[4] = {-1, 0, 1, 0};
int y_move[4] = {0, 1, 0, -1};
bool flag;

void dfs (int x, int y, int dir)	//dir为当前方向
{
if (x == ex && y == ey)
{
if (wan[x][y] <= k)
flag = true;
return ;
}
if (wan[x][y] > k)	//转弯数超过k不用往下走了
return ;
//x !=ex && y != ey 说明必须至少再转一次弯,但是已经不能再转了
if (wan[x][y] == k && x !=ex && y != ey)
return ;
for (int i = 0; i < 4; i++)
{
int tx = x + x_move[i];
int ty = y + y_move[i];
if (tx < 0 || tx >= r || ty < 0 || ty >= c)
continue;
//转弯数相等不可剪掉,所以是wan[tx][ty] < wan[x][y]而不是wan[tx][ty] <= wan[x][y]
if (map[tx][ty] == '*' || wan[tx][ty] < wan[x][y])	//转弯数剪枝
continue;
if (dir != -1 && i != dir && wan[tx][ty] < wan[x][y] + 1)	//转弯数剪枝
continue;
wan[tx][ty] = wan[x][y];
if (dir != -1 && i != dir)
wan[tx][ty]++;	//如果方向变了转弯+1
dfs (tx, ty, i);
if (flag)
return ;
}
}

int main()
{
int t, i, j, sx, sy;	//sx, sy是起点
scanf ("%d", &t);
while (t--)
{
scanf ("%d%d", &r, &c);
for (i = 0; i < r; i++)
scanf ("%s", map[i]);
scanf ("%d%d%d%d%d", &k, &sy, &sx, &ey, &ex);
sx--, sy--, ex--, ey--;		//我从0开始编号,而题目是从1开始
for (i = 0; i < r; i++)
for (j = 0; j < c; j++)
wan[i][j] = inf;	//初始化转弯数和步数为无穷大
wan[sx][sy] = 0;	//到达起点的转弯数
flag = false;
dfs (sx, sy, -1);	//一开始可以走任意方向,所以设方向为-1
if (flag)
puts ("yes");
else puts ("no");
}
return 0;
}


二 BFS

融合深搜思想的广搜【单方向优先扩展】

#include <iostream>
#include <queue>
using namespace std;
#define inf 0x3fffffff
#define M 105

int r, c, sx, sy, ex, ey, wan[M][M], t, k;
char map[M][M];
int x_move[4] = {-1, 0, 1, 0};
int y_move[4] = {0, 1, 0, -1};

struct pos{
int x, y;
};

void bfs ()
{
int i, j;
for (i = 0; i < r; i++)
for (j = 0; j < c; j++)
wan[i][j] = inf;
pos ft, tp;
ft.x = sx, ft.y = sy;
wan[ft.x][ft.y] = -1;
queue<pos> q;
q.push (ft);
while (!q.empty())
{
ft = q.front();
q.pop();
if (ft.x == ex && ft.y == ey && wan[ft.x][ft.y] <= k)
{
puts ("yes");
return ;
}
for (i = 0; i < 4; i++)
{
tp.x = ft.x + x_move[i];
tp.y = ft.y + y_move[i];
while (!(tp.x < 0 || tp.y < 0 || tp.x >= r || tp.y >= c))
{
if (map[tp.x][tp.y] == '*')
break;
if (wan[tp.x][tp.y] < wan[ft.x][ft.y] + 1)
break;
wan[tp.x][tp.y] = wan[ft.x][ft.y] + 1;
if (wan[tp.x][tp.y] > k)
break;
if (wan[tp.x][tp.y] == k && tp.x != ex && tp.y != ey)
break;
q.push (tp);
tp.x += x_move[i];
tp.y += y_move[i];    //单方向优先扩展
}
}
}
puts ("no");
}

int main()
{
int t, i;
scanf ("%d", &t);
while (t--)
{
scanf ("%d%d", &r, &c);
for (i = 0; i < r; i++)
scanf ("%s", map[i]);
scanf ("%d%d%d%d%d", &k, &sy, &sx, &ey, &ex);
sx--, sy--, ex--, ey--;
bfs ();
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: